#include <iostream>  
#include <assert.h>  
using namespace std;

#define MAXSTR 300


struct url_t {

	char uri[MAXSTR]; //This stores the actual address e.g., "https://www.tamu.edu"
	bool is_bookmarked; // True iff this is a fav.

	url_t *link; // The previous url we visited

};


void url_print(url_t *u)
{
	if (u != NULL)
	{
		cout << u->uri;
		if (u->is_bookmarked)
			cout << " * ";
		cout << endl;
	}
	else

		cout << "(null url)" << endl;
}

bool get_bool()
{
	while (true)
	{
		char c;
		cin >> c;
		switch (c)
		{
			case 'y':
			case 'Y': return true;
			case 'n':
			case 'N': return false; 
			default:
				cerr << "Please enter Y or N!" << endl;
		}
	}

}

url_t *url_new()
{
	url_t *ret = new url_t;

	cout << "Enter URL: " << endl;
	cin >> ret->uri;
	cout << "Is this a favorite?: " << endl;
	ret->is_bookmarked = get_bool();

	ret->link = NULL;

	return ret;
}
	

void url_destroy(url_t *u)
{
	assert(u != NULL);

	cout << "We're destroying [" << u->uri << "]" << endl;
	delete u;
}


bool is_stack_empty(url_t *top_of_stack)
{
	return	(top_of_stack == NULL);
}

void push(url_t **top_of_stack, url_t *u)
{
	assert(u != NULL);
	u->link = *top_of_stack;
	*top_of_stack = u;
}

url_t *pop(url_t **top_of_stack)
{ // This should remove the element from the top of our stack
  // and return that element.
	
	assert(top_of_stack != NULL);

	url_t *former_top = *top_of_stack;
	*top_of_stack = (*top_of_stack)->link;
	former_top->link = NULL;
	return former_top;
}

void stack_print(url_t *top_of_stack)
{
	// This navigates the stack, starting at the top and progressing downwards, printing each element.
	if (top_of_stack == NULL)
	{
		cout << "The stack is empty" << endl;
	}
	else
	{
		int counter = 0;
		url_t *walker = top_of_stack;
		while (walker != NULL)
		{
			cout << "#" << counter++ << ": ";
			url_print(walker);
			walker = walker->link; // move down the chain
		}

	}

}


void stack_destroy(url_t **top_of_stack)
{
	while (!is_stack_empty(*top_of_stack))
		url_destroy(pop(top_of_stack));
	//Puzzle: Do I just put an & before top_of_stack?

}

int main(int argc, char **argv)
{
	url_t *stacktop = NULL;
	url_t *homepage = NULL;

	cout << "Zero'th print" << endl;
	stack_print(stacktop);

	cout << "Let's start with your homepage---";
	homepage = url_new();


	// do stuff with it
	
	push(&stacktop, homepage);	
	push(&stacktop, url_new());	
	push(&stacktop, url_new());	

	cout << "First print" << endl;
	stack_print(stacktop);

	url_t *last = pop(&stacktop);

	cout << "Second print" << endl;
	stack_print(stacktop);

	url_destroy(last);

	cout << "Stack destroy: " << endl;
	stack_destroy(&stacktop);
	cout << "stacktop = " << stacktop << endl;
	
	//cout << "Manual stack destroy: " << endl;
	//url_destroy(pop(&stacktop));
	//url_destroy(pop(&stacktop));

	cout << "Third print" << endl;
	stack_print(stacktop);

	push(&stacktop, url_new());	

	cout << "Fourth print" << endl;
	stack_print(stacktop);

	return 0;
}

